//------------------------------------------------------
//
//   Greg's Blocks Mod - Client Proxy
//
//------------------------------------------------------

package gcewing.blocks;

import java.io.File;
import org.lwjgl.input.Keyboard;

import net.minecraft.entity.player.*;
import net.minecraft.src.*;
import net.minecraft.tileentity.*;
import net.minecraft.world.*;

import net.minecraft.client.Minecraft;
import net.minecraftforge.client.MinecraftForgeClient;
import cpw.mods.fml.client.registry.RenderingRegistry;

public class ProxyClient extends Proxy {

	public static Minecraft minecraft;

	public void load() {
		minecraft = ModLoader.getMinecraftInstance();
		loadTextures();
		super.load();
		registerBlockModels();
		registerRenderers();
	}

	void loadTextures() {
		//System.out.printf("mod_GregsBlocks: loadTextures()\n");
		MinecraftForgeClient.preloadTexture(GregsBlocks.textureFile);
	}
	
	void registerBlockModels() {
		BlockShape.modelID = RenderingRegistry.getNextAvailableRenderId();
	}
	
	void registerRenderers() {
		RenderingRegistry.registerBlockHandler(BlockShape.modelID, new RenderShape());
		MinecraftForgeClient.registerItemRenderer(GregsBlocks.blockShape.idDropped(0, null, 0), new RenderItemShape());
	}
	
	@Override
	public World getWorld() {
		return minecraft.theWorld;
	}
	
	/**
	 * Returns a Container to be displayed to the user. 
	 * On the client side, this needs to return a instance of GuiScreen
	 * On the server side, this needs to return a instance of Container
	 *
	 * @param ID The Gui ID Number
	 * @param player The player viewing the Gui
	 * @param world The current world
	 * @param x X Position
	 * @param y Y Position
	 * @param z Z Position
	 * @return A GuiScreen/Container to be displayed to the user, null if none.
	 */
	public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
		//System.out.printf("ProxyClient.getClientGuiElement: %d\n", id);
		TileEntity te = world.getBlockTileEntity(x, y, z);
		if (te != null) {
			//System.out.printf("ProxyClient.getClientGuiElement: have te\n");
			switch (id) {
				case guiSawbench:
					return new GuiSawbench(player.inventory, (TESawbench)te);
			}
		}
		return null;
	}

}
