//------------------------------------------------------
//
//   Greg's Blocks Mod - Shaped block item renderer
//
//------------------------------------------------------

package gcewing.blocks;

import net.minecraft.block.*;
import net.minecraft.client.renderer.*;
import net.minecraft.item.*;
import net.minecraft.nbt.*;
import net.minecraft.world.*;

import net.minecraftforge.client.*;

public class RenderItemShape implements IItemRenderer {

//	static IBlockAccess blockAccess = new DummyBlockAccess();

	public boolean handleRenderType(ItemStack item, ItemRenderType type) {
		return true;
	}
	
	public boolean shouldUseRenderHelper(ItemRenderType type, ItemStack item, ItemRendererHelper helper) {
		boolean result;
		switch (helper) {
			case ENTITY_ROTATION:
			case ENTITY_BOBBING:
			case EQUIPPED_BLOCK:
			case BLOCK_3D:
			case INVENTORY_BLOCK:
				result = true;
				break;
			default:
				result = false;
		}
		//System.out.printf("RenderItemShape.shouldUseRenderHelper: %s %s --> %s\n",
		//	type, helper, result);
		return result;
	}
	
	public void renderItem(ItemRenderType type, ItemStack stack, Object... data) {
		//System.out.printf("RenderItemShape.renderItem: %s\n", type);
		switch (type) {
			case ENTITY:
			case INVENTORY:
			case EQUIPPED:
				render(stack, (RenderBlocks)data[0]);
				break;
		}
	}
	
	void render(ItemStack stack, RenderBlocks renderBlocks) {
		//System.out.printf("RenderItemShape.render\n");
		NBTTagCompound tag = stack.getTagCompound();
		if (tag != null) {
			TEShape te = new TEShape();
			te.readFromNBT(tag);
			Tessellator tess = Tessellator.instance;
			tess.startDrawingQuads();
			RenderShape.render(null, GregsBlocks.blockShape, 2, te, 0, 0, 0);
			tess.draw();
		}
	}

}
